package platform_user

import (
	"encoding/json"
	"fmt"
	"testing"
)

func TestRetrieveBilibili(t *testing.T) {
	str := `{
    "error": "",
    "message": [
        {
            "id": 48,
            "ip": "120.42.46.226",
            "port": "6666",
            "scheme_type": 0,
            "content": "120.42.46.226:6666",
            "assess_times": 16,
            "success_times": 14,
            "avg_response_time": 2.063625,
            "continuous_failed_times": 0,
            "score": 3.7924709776481986,
            "insert_time": 1650852112,
            "update_time": 1650853064
        }
    ]
}`
	var respStruct struct {
		Error   string    `json:"error"`
		Message []MyProxy `json:"message"`
	}
	err := json.Unmarshal([]byte(str), &respStruct)
	if err != nil {
		return
	}
	fmt.Printf("%+v\n", respStruct)

	bilibili, err := RetrieveBilibili("2")
	if err != nil {
		fmt.Println(err)
		return
	}
	fmt.Printf("%+v\n", bilibili)
}
