package nerr

// 成功返回
const OK uint32 = 200

/** 前3位标识业务，后3位标识具体功能 **/

// 全局错误

const (
	ServerCommonError uint32 = iota + 100001
	RequestParamError
	TokenExpireError
	TokenGenerateError
	DBError
	DBUpdateAffectedZeroError
	CopyError
)

// 业务错误

// 用户积分相关 UserIntegral
const (
	UserIntegralNotEnoughError uint32 = iota + 200100 // 用户积分不足
	NewUserIntegralError                              // 新建用户积分失败
	GetUserIntegralError                              // 获取用户积分失败
	UpdateUserIntegralError                           // 更新用户积分失败
)

// 礼包相关 GiftPack

const (
	GiftPackHasDrawError          uint32 = 201100 // 该礼包已经领取过
	GiftPackDrawCountLimitedError        = 201101 // 该礼包已领取完
)

// 礼物相关 Gift

const (
	GiftRecordErr         uint32 = 202100 // 礼物记录失败
	GiftNobilityUpdateErr        = 202101 // 更新贵族信息失败
)

// 排行相关

const (
	RankStatisticsSelectError uint32 = 203100 // 获取统计数据失败
)

// 用户金币(Coin)相关 UserCoin
const (
	UserCoinNotEnoughErr uint32 = iota + 204100 // 用户金币不足
	NewUserCoinErr                              // 新建用户金币失败
	GetUserCoinErr                              // 获取用户金币失败
	UpdateUserCoinErr                           // 更新用户金币失败
)
